%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%			  VECTORS IN ERLANG
%
% Abstract interface to vectors.

-define(impl,hipe_pure_vectors).

-module(hipe_vectors).
-export([set/3,
	 set_all/3,
	 get/2,
	 get_all/2,
	 vsize/1,
	 is_vector/1,
	 verify_vector/1,
	 vector_to_list/1,
	 list_to_vector/1,
	 empty/1, 
	 empty/2,
	 init/1,
	 init/2,
	 list/1,
	 first_index/0
	]).

set(A,B,C) ->
    ?impl:set(A,B,C).

set_all(A,B,C) ->
    ?impl:set_all(A,B,C).

get(A,B) ->
    ?impl:get(A,B).

get_all(A,B) ->
    ?impl:get_all(A,B).

vsize(V) ->
    ?impl:vsize(V).

is_vector(V) ->
    ?impl:is_vector(V).

verify_vector(V) ->
    ?impl:verify_vector(V).

vector_to_list(V) ->
    ?impl:vector_to_list(V).

list_to_vector(V) ->
    ?impl:list_to_vector(V).

empty(E) ->
    ?impl:empty(E).

empty(A,B) ->
    ?impl:empty(A,B).

init(Xs) ->
    ?impl:init(Xs).

init(A,B) ->
    ?impl:init(A,B).

list(V) ->
    ?impl:list(V).

first_index() ->
    ?impl:first_index().
